#ifndef _AM29F0X0_
#define _AM29F0X0_

#include <ihx.h>

#include "memchip.h"
#include "flashpgm.h"

using namespace ihx;

class am29f0x0 : public memchip {
	public:
		am29f0x0(flashpgm *pgm);
		virtual ~am29f0x0() {}
		int manufacture_code();
		int device_code();
		void reset();
		bool detect();
		const char *device_name() const;
		unsigned long space() const;
		unsigned long sector_address(int id) const;
		bool erase_all();
		bool erase_sector(unsigned long sectaddr);
		bool write(const Buffer &buf);

	private:
		typedef struct {
			const char *name;
			unsigned char manufacture;
			unsigned char code;
			unsigned long sector_size[9];
		} device;

		static device devices[];
		device *dev;

		void command(unsigned char cmd, unsigned long cmdaddr = 0x5555);
		bool toggle_check(unsigned char b1, unsigned char b2);
		bool poll(unsigned long addr);
		bool write_byte(unsigned long addr, unsigned char d);
};

#endif
