#ifndef _FLASHPGM_H_
#define _FLASHPGM_H_

class lpt;

class flashpgm {
	public:
		bool deleteppd;

		flashpgm(lpt *ppd = (lpt*)0);
		~flashpgm();
		bool preinit();
		void init();
		bool detect(int retries = 1);
		void led(bool green, bool red);
		void address(unsigned long addr);
		void write_at(unsigned long addr, unsigned char byte);
		unsigned char read_at(unsigned long addr);
		void flash_ctrl(bool ce, bool oe, bool we);

	private:
		static const unsigned int N_REGS = 8;
		void select(int id);
		void write(unsigned char data);
		bool _detect();
		unsigned char read();
		void reg(int id, unsigned char data);
		unsigned char reg(int id) const {
			return ((unsigned int)id >= N_REGS) ? -1 : c_reg[id];
		}

		lpt *pp;
		int c_select, c_reg[N_REGS];
};

#endif
