#ifndef _LPT_H_
#define _LPT_H_

#define LPT1	0x378
#define LPT2	0x278

typedef unsigned short int lpt_port_t;

typedef enum {
	lptm_standard = 0,
	lptm_byte,
	lptm_fifo,
	lptm_ecp_fifo,
	lptm_epp,
	lptm_reserved,
	lptm_fifo_test,
	lptm_config
} lpt_mode;

class lpt {
	public:
		lpt(lpt_port_t port = LPT1) {
			this->port = port;
		}

		bool init();
		unsigned char ecr() const { return c_ecr; }
		unsigned char ecr(unsigned char ecr);
		unsigned char status();
		unsigned char control() const { return c_control; }
		unsigned char control(unsigned char ctrl);
		bool output_enable() const;
		bool output_enable(bool enable);
		bool busy();
		bool ack();
		bool paper_out();
		bool select_in();
		bool error();
		bool irq();
		void data(unsigned char data);
		unsigned char data();
		bool strobe();
		void strobe(bool s);
		void strobe_pulse(int waitmsec = 0);
		bool select_printer() const;
		bool select_printer(bool s);
		bool init_printer() const;
		bool init_printer(bool i);
		bool auto_linefeed() const;
		bool auto_linefeed(bool alf);

		lpt_mode mode() const;
		lpt_mode mode(lpt_mode mode);

	private:
		lpt_port_t port;
		unsigned char c_control, c_ecr;
};

#endif
